From 6f12a935c71837c40a98efe2b4e957c6ce7ec143 Mon Sep 17 00:00:00 2001
From: nbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>
Date: Sun, 25 Feb 2007 12:52:02 +0000
Subject: [PATCH] integrate the fix from #1348 and clean up the network scripts
 a bit...

git-svn-id: svn://svn.openwrt.org/openwrt/trunk@6355 3c298f89-4303-0410-b956-a3cf2f4a3e73
---
 .../base-files/files/lib/network/config.sh    | 57 +++++++++++++------
 1 file changed, 39 insertions(+), 18 deletions(-)

diff --git a/package/base-files/files/lib/network/config.sh b/package/base-files/files/lib/network/config.sh
index ffe637bbf0..2b1574937b 100755
--- a/package/base-files/files/lib/network/config.sh
+++ b/package/base-files/files/lib/network/config.sh
@@ -62,19 +62,18 @@ add_vlan() {
 	}
 }
 
-setup_interface() {
+# Create the interface, if necessary.
+# Return status 0 indicates that the setup_interface() call should continue
+# Return status 1 means that everything is set up already.
+
+prepare_interface() {
 	local iface="$1"
 	local config="$2"
-	local proto
-	local macaddr
 
-	[ -n "$config" ] || {
-		config=$(find_config "$iface")
-		[ "$?" = 0 ] || return 1
-	}
-
-	proto="${3:-$(config_get "$config" proto)}"
-	config_get iftype "$config" type
+	# if we're called for the bridge interface itself, don't bother trying
+	# to create any interfaces here. The scripts have already done that, otherwise
+	# the bridge interface wouldn't exist.
+	[ "$iface" = "br-$config" ] && return 0;
 	
 	ifconfig "$iface" 2>/dev/null >/dev/null && {
 		# make sure the interface is removed from any existing bridge and brought down
@@ -86,28 +85,50 @@ setup_interface() {
 	add_vlan "$iface"
 
 	# Setup bridging
+	config_get iftype "$config" type
 	case "$iftype" in
 		bridge)
 			[ -x /usr/sbin/brctl ] && {
 				ifconfig "$iface" up 2>/dev/null >/dev/null
 				ifconfig "br-$config" 2>/dev/null >/dev/null && {
 					$DEBUG brctl addif "br-$config" "$iface"
-					return 0
+					# Bridge existed already. No further processing necesary
 				} || {
 					$DEBUG brctl addbr "br-$config"
 					$DEBUG brctl setfd "br-$config" 0
 					$DEBUG brctl addif "br-$config" "$iface"
-					iface="br-$config"
-				
-					# need to bring up the bridge and wait a second for 
-					# it to switch to the 'forwarding' state, otherwise
-					# it will lose its routes...
-					ifconfig "$iface" up
-					sleep 1
+					# Creating the bridge here will have triggered a hotplug event, which will
+					# result in another setup_interface() call, so we simply stop processing
+					# the current event at this point.
 				}
+				return 1
 			}
 		;;
 	esac
+	return 0
+}
+
+setup_interface() {
+	local iface="$1"
+	local config="$2"
+	local proto
+	local macaddr
+
+	[ -n "$config" ] || {
+		config=$(find_config "$iface")
+		[ "$?" = 0 ] || return 1
+	}
+	proto="${3:-$(config_get "$config" proto)}"
+	
+	prepare_interface "$iface" "$config" || return 0
+	
+	[ "$iface" = "br-$config" ] && {
+		# need to bring up the bridge and wait a second for 
+		# it to switch to the 'forwarding' state, otherwise
+		# it will lose its routes...
+		ifconfig "$iface" up
+		sleep 1
+	}
 	
 	# Interface settings
 	config_get mtu "$config" mtu
-- 
GitLab